import org.aspectj.lang.annotation.Pointcut;


public class Point implements Shape, ExceptionSignalling {
	int x, y; 

	// starting crosscutting contract specifications in AspectJML with pointcuts + specifications
	  
	 //@ requires xy >= 0;
	 @Pointcut("execution(* Point.set*(int)) && args(xy)")
	 void sets(int xy) {} 
	  
	 // note that we need to cast the \result to the desired return type 
	 // when used within pointcut expressions
	 //@ ensures ((int)\result) >= 0; 
	 @Pointcut("execution(int Point.get*())")
	 void gets() {} 
	  
	 // ending of the crosscutting contract specifications in AspectJML
	 
	 //@ ensures this.x == x;
	 void setX(int x) {
	  this.x = x;
	 }
	  
	 //@ ensures this.y == y;
	 void setY(int y) {
	  this.y = y;
	 }
	  
	 int getX() { return this.x; }
	  
	 int getY() { return this.y; } 
	     
	 //@ requires dx >= 0 && dy >= 0;
	 //@ ensures this.x == \old(this.x + dx)
	 //@       && this.y == \old(this.y + dy);
	 void moveBy(int dx, int dy) {
		 this.x += dx; this.y += dy;
	 }
}
