
public class Point implements Shape {
	int x, y; 

	//@ requires x >= 0;
	//@ ensures this.x == x;
	//@ signals_only \nothing;
	void setX(int x) {
		this.x = x;
	}

	//@ requires y >= 0;
	//@ ensures this.y == y;
	//@ signals_only \nothing;
	void setY(int y) {
		this.y = y;
	}

	//@ ensures \result >= 0;
	//@ signals_only \nothing;
	int getX() { return this.x; }

	//@ ensures \result >= 0;
	//@ signals_only \nothing;
	int getY() { return this.y; } 

	//@ requires dx >= 0 && dy >= 0;
	//@ ensures this.x == \old(this.x + dx)
	//@       && this.y == \old(this.y + dy);
	//@ signals_only \nothing;
	void moveBy(int dx, int dy) {
		this.x += dx; this.y += dy;
	}
}
